import { useRef } from 'react';
import useAsync from './useAsync';
import usePaginated from './usePaginated';

function useAPI(service) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var paginated = options.paginated;
  var paginatedRef = useRef(paginated);

  if (paginatedRef.current !== paginated) {
    throw Error('You should not modify this paginated of options');
  }

  paginatedRef.current = paginated;

  if (paginated) {
    return usePaginated(service, options);
  } else {
    return useAsync(service, options);
  }
}

export default useAPI;