import { useCallback, useRef } from 'react';

function useLimitFn(fn, timespan) {
  var pending = useRef(false);
  var fnRef = useRef(fn);
  fnRef.current = fn;
  var run = useCallback(function () {
    if (pending.current) {
      return;
    }

    pending.current = true;
    fnRef.current.apply(fnRef, arguments);
    setTimeout(function () {
      pending.current = false;
    }, timespan);
  }, [timespan]);
  return run;
}

export default useLimitFn;