"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _useAsync = _interopRequireDefault(require("./useAsync"));

var _usePaginated = _interopRequireDefault(require("./usePaginated"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function useAPI(service) {
  var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var paginated = options.paginated;
  var paginatedRef = (0, _react.useRef)(paginated);

  if (paginatedRef.current !== paginated) {
    throw Error('You should not modify this paginated of options');
  }

  paginatedRef.current = paginated;

  if (paginated) {
    return (0, _usePaginated.default)(service, options);
  } else {
    return (0, _useAsync.default)(service, options);
  }
}

var _default = useAPI;
exports.default = _default;