"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

function useLimitFn(fn, timespan) {
  var pending = (0, _react.useRef)(false);
  var fnRef = (0, _react.useRef)(fn);
  fnRef.current = fn;
  var run = (0, _react.useCallback)(function () {
    if (pending.current) {
      return;
    }

    pending.current = true;
    fnRef.current.apply(fnRef, arguments);
    setTimeout(function () {
      pending.current = false;
    }, timespan);
  }, [timespan]);
  return run;
}

var _default = useLimitFn;
exports.default = _default;